;Basis: RasterIRQ-Routine aus dem "Das neue Commodore64 Intern Buch"
;vertikaler Scroller hinzu. Statuszeile springt
;20.3.13: $1f nach $d011 schreiben: Springen gelst, letzte Zeile aber nur obere 4 Pixel sichtbar.
;21.3.13: RasterIRQ auf stabiles Timing gendert, 3. Bereich zum Border ffnen hinzu
;Plattformabstnde = 9 Leerzeilen wie in Amiga-Version
;24.3.13: Versuch mit Musik ber externe Dateien laden
;25.3.13: ein improvisierter Titelscreen, Code in Zonen unterteilt
;29.3.13: Scroll-Hardcopy kopiert nur noch jede 9. Zeile -> deutlich schneller
;30.3.13: Punktezhler hinzu, Pickfruits hinzu, Textausgabe nicht mehr nur Mll
;1.4.13: Plattformreihen werden aus Leveldaten generiert
;4.4.13: Sprite-Animation, erster Test fr ein Koala-Titelbild (Ladeadresse ist frei)
;5.4.13: Titelbild eingebaut, Sprite-Hngenbleib-Kontrolle eingebaut
;6.4.13: Font angepasst, Grenzen fr Playersprite gendert (war teilweise unspielbar)
;7.4.13: Leveldaten komplettiert, Berechnung fr Levelpointer eingebaut
;8.4.13: 24 Picksprites mit einzeln Mehrfarbmglichkeit, Titelscreen mit Wechseltimer
;11.4.13: eine improvisierte Highscorelisten-Ausgabe
;13.4.13: Highscore wird einsortiert
;14.4.13: Highscore + Namenseingabe funktioniert, wird geladen und gespeichert
;		jetzt wirds eng im RAM, Highscore-Routinen nach hinten verlagert
;20.4.13: simpler Credits-Screen
;28.4.13: 10sec-Timer und Behandlung von Double und Half Score eingebaut

!to "downfall.prg",cbm

rz_topline = $2c		;$1f: oben eine Begrenzungslinie zeichnen
rz_oben = $ed			;$ed: Plattformen im roten Streifen, $ef Datenmll, >ef Geflacker
rz_border = $f8			;in $f8 Zeilenmodus wechseln fr Border abschalten
rz_unten = $fe			;$fa ist genau untere Sichtbarkeitskante
; Verschieberegister = $d011 ; 53265 dez, Einschaltwert = 00011011 = $1b = 27
LevelArrayPointer = $2f	;Zeiger auf die Position der aktuellen Zeile in den Leveldaten
TimeCounter = $b0	;Original Zeitkonstante Band
DelayCounter = $b1
;$fb wird von Musikplayer verwendet
Testpos = $07cb
SETLFS = $ffba	;Dateiparameter festlegen
SETNAM = $ffbd	;Dateinamen definieren
OPEN   = $ffc0	;Datei ffnen
CLOSE  = $ffc3	;Datei schlieen
CHKOUT = $ffc9	;Ausgabekanal definieren
CLRCHN = $ffcc	;alle Kanle freigeben, Standard einstellen
BSOUT  = $ffd2	;ein Byte ausgeben
GETIN  = $ffe4  ;Tastaturpuffer lesen

*=$0801

	;SYS 2064
		!byte $0C,$08,$0A,$00,$9E,$20,$32,$30,$36,$34,$00,$00,$00,$00,$00

!zone TitleScreen		;der Titelscreen
		jsr FirstInit	;generelle Basiswerte initialisieren
Start
		;jsr ShowHighscore
		;jsr InputString
		jsr ShowKoalapic
		lda #$e0		;Joystick-Eingnge schalten
		;sta $dc02
		;noch funktionierende Tasten: [Linkspfeil]12+-[Pfund][Home]qp@*[Hochpfeil][Runstop]l:;=,./[Leertaste]
		lda #$00
		sta DelayCounter
WaitForInput
		lda #$10		;Feuerknopf
		bit $dc00		;Joyport 2
		beq	StartbuttonPressed	;gedrckt? dann Spiel starten
		jsr $ffe4		;Tastaturabfrage
		cmp #$20		;Leertaste
		beq StartbuttonPressed	;gedrckt? dann Spiel starten
		cmp #$4d		;M-Taste
		bne +
		jsr MusicOnOff	;Musik ein/ausschalten
		jmp WaitForInput
+		lda DelayCounter	;zyklisches Umschalten der 3 Startbildschirme
		cmp #$04
		bne +
		jsr ShowHighscore
		inc DelayCounter
		jmp WaitForInput
+		cmp #$08
		bne +
		jsr ShowCredits
		inc DelayCounter
		jmp WaitForInput
+		cmp #$0b
		bcc WaitForInput
		jsr ShowKoalapic
		lda #$00
		sta DelayCounter
		jmp WaitForInput
StartbuttonPressed
		jsr GameInit
		jsr GameMain
		jsr CheckHighscore
		jmp Start

!zone GameInit		
GameInit	;Initialisieren des Spiels
		lda #$03		;VIC Bank 0
		ora $dd00
		sta $dd00
		lda #$c8		;Multicolor aus
		sta $d016
		jsr $e544		;Bildschirm lschen
		lda #$00		;Spielwerte initialisieren
		sta Counter_Platformlines
		sta Counter_Scrollregister
		sta ActivePickType
		sta CurrentPickType
		lda #$01
		sta Counter_Spacelines
		sta Level_Nr
		sta GameTimingFlag
		lda #$32
		sta FrameTimer
		;Sprites
		lda $d010
		and #$40
		sta $d010		;MSB 0-5 + 7 lschen
		lda #1			;Multicolor1 wei
		sta $d025
		lda #0			;Multicolor2 schwarz
		sta $d026
		;Sprite Player1
		lda #8			;Sprite 0 Farbe braun
		sta $d027
		lda #(sprites/64)	;Sprite-Pointer
		sta $07f8
		lda #$64		;X-/Y-Position des Sprites auf 100/29
		sta $d000
		lda #$3d
		sta $d001
		lda $d015
		and #%01000000	;alle Sprites auer 6 aus
		ora #%00000001
		sta $d015		;Sprite 0 einschalten
		lda $d01c
		ora #%00000001
		sta $d01c		;Sprite 0 Multicolor einschalten
		;Sprite Player2
		lda NumberOfPlayers	;2-Spieler-Modus?
		beq PrintStatusline	;wenn nicht, Sprite-Init berspringen
		lda #8			;Sprite 1 Farbe braun
		sta $d028
		lda #(sprites/64)+4	;Sprite-Pointer
		sta $07f9
		lda #$dc		;X-/Y-Position des Sprites auf 220/29
		sta $d002
		lda #$3d
		sta $d003
		lda $d015		;Enable-Register
		ora #%00000010	;+ Sprite2
		sta $d015
		lda $d01c		;Multicolor-Register
		ora #%00000010	;+ Sprite2
		sta $d01c
PrintStatusline
		;Statuszeile ausgeben
		ldx #$18		;Cursor auf letzte Zeile
		ldy #$00		;erste Spalte
		clc				;Carry lschen schaltet Routine auf
		jsr $fff0		;Cursor setzen
		lda #<StatuslineText
		ldy #>StatuslineText
		jsr $ab1e		;String ausgeben
		lda #$00		;Zeichenfarbe schwarz
		ldy #$27
-		sta $dbc0,y		;unterste Zeile schwrzen
		dey
		bpl -
		lda #$32		;Sekundentimer (50 Frames) initialisieren
		sta FrameTimer
		lda #$05		;Zeichen-Farbe Grn
		sta $0286
		jsr CreatePlatformLine	;die erste Plattformreihe in den Zwischenspeicher
		;lda $d018		;Zeichensatz bei $2800 einschalten
		;and #$f0		;Bit 3-1 lschen
		;ora #$0a		;1024*10=$2800
		;sta $d018
		lda #$1a		;Videospeicher bei $0400, Zeichensatz bei $2800
		sta $d018
	
	;Initialisieren des Split-Scrollers
		sei
		lda #$7f		;Timer-IRQ abschalten
		sta $dc0d
		lda $dc0d		;ICR lschen
		lda #rz_oben	;Rasterzeile $f0 als Inter-
		sta $d012		; ruptauslser festlegen
		lda $d011		;Bit 7 in $D011
		and #$7f		; lschen.
		sta $d011
		lda #$01		;Rasterstrahl als Inter-
		sta $d01a		; rupt-quelle definieren
		ldx #<(irq_raster_oben)	;IRQ-Vektor bei $0314/
		ldy #>(irq_raster_oben)	; $0315 auf erste
		stx $0314		; Interrupt-
		sty $0315		; Routine verbiegen
		
		lda #$07		;Zhler fr Verschieberegister
		sta Counter_Scrollregister
		cli
		
		; musik initialisieren
		lda MusicEnabled
		beq +
		lda #$00		; subtune 0
		tax
		tay
		jsr $1000		; init adresse 
+		rts

!zone RasterIRQs
irq_raster_topline
		;Rasterstart ist nicht stabil, ich lasse das mal als "Hochspannungseffekt"
		nop
		nop
		nop
		nop
		lda #$01		;Farbe auf wei
		sta $d021		;Hintergrundfarbe setzen
		lda #rz_oben	;Zeile $fa als Auslser
		sta $d012		; fr nchsten IRQ festl.
		dec $d019		;VIC-IRR lschen
		ldx #<(irq_raster_oben) ;IRQ-Vektor auf
		ldy #>(irq_raster_oben) ; dritte Interrupt-
		stx $0314		; Routine
		sty $0315		; verbiegen
		lda #$06		;Farbe auf blau
		sta $d021		;Hintergrundfarbe setzen
		jmp $ea81		;IRQ abschlieen

irq_raster_oben			;Oberkante des feststehenden Statusbereichs
	;dec $d020
	nop		;ohne das flackert die vorletzte Zeile
		lda #rz_border	;Zeile $f8 als Auslser
		sta $d012		; fr nchsten IRQ festl.
		dec $d019		;VIC-IRR lschen
		ldx #<(irq_raster_border) ;IRQ-Vektor auf
		ldy #>(irq_raster_border) ; zweite Interrupt-
		stx $0314		; Routine
		sty $0315		; verbiegen
		lda #$04		;Farbe auf purpur
		;sta $d020		;Rahmenfarbe setzen
		sta $d021		;Hintergrundfarbe setzen
		lda #$1f		;Verschieberegister auf max Verschiebung
		sta $d011		;und speichern
		jmp $ea81		;IRQ abschlieen

irq_raster_border
		lda $d011		;Bildschirm
		and #$f7		; auf 24 Zeilen
		sta $d011		; Umschalten
		lda #rz_unten	;Zeile $fa als Auslser
		sta $d012		; fr nchsten IRQ festl.
		dec $d019		;VIC-IRR lschen
		ldx #<(irq_raster_unten) ;IRQ-Vektor auf
		ldy #>(irq_raster_unten) ; dritte Interrupt-
		stx $0314		; Routine
		sty $0315		; verbiegen
		jmp $ea81		;IRQ abschlieen
		;das Zurckschalten auf 25 Zeilen bernimmt der 3. Bereich

irq_raster_unten		;Ende des sichtbaren Bereichs
		lda #rz_topline	;Zeile $e8 als Auslser
		sta $d012		; fr nchsten IRQ festl.
		dec $d019		;VIC-IRR lschen
		ldx #<(irq_raster_topline) ;IRQ-Vektor auf
		ldy #>(irq_raster_topline) ; dritte Interrupt-
		stx $0314		; Routine
		sty $0315		; verbiegen
		
		lda #$00		;Farbe auf schwarz
		;sta $d020		;Rahmenfarbe setzen
		lda #$06		;Farbe auf blau
		sta $d021		;Hintergrundfarbe setzen
					;Verschiebung im Scroll-Bereich fr nchsten Bilddurchlauf setzen
		;lda $d011		;Verschieberegister laden
		;and #$f8		;untere 3 Bits lschen
		lda #$18		;Textmodus mit 25 Zeilen
		;lda #$10		;Textmodus mit 24 Zeilen
		ora Counter_Scrollregister	;aktuelle Verschiebung setzen
		sta $d011		;speichern
		lda Counter_Scrollregister
		cmp #$07
		bne dontMoveScreenUp
		jsr MoveScreenUp
dontMoveScreenUp		
		dec Counter_Scrollregister	;Zhler vermindern
		bpl Not7Pixel	
		lda #$07		;Verschiebezhler neu initialisieren
		sta Counter_Scrollregister
Not7Pixel
		lda MusicEnabled
		beq +
		jsr $1003		;Musikplayer aufrufen
		lda #$00		;Spielkontrolle freigeben
+		sta GameTimingFlag
	;inc $d020
		jmp $ea81		;IRQ abschlieen
		
!zone TimerIRQs
;das ist kein echter Timer, die Routine hngt sich nur in den normalen IRQ
SetTimer				;Akku=1/60s-Zhler, X+Y=Zieladresse
		sei
		sta TimeCounter
		stx TimerJump+1
		sty TimerJump+2
		ldx #<GetTimer
		ldy #>GetTimer
		stx $0314
		sty $0315
		cli
		rts

;im IRQ einen Speicherzelle bis 0 runterzhlen, dann Routine ausschalten und eingestellte Adresse anspringen		
GetTimer
		dec TimeCounter
		bne +
		ldx #$31
		ldy #$ea
		stx $0314
		sty $0315
TimerJump
		jsr $0000		;das sollte sich modifizieren
+		jmp $ea31
		
;Subroutine Reset_RTC nullt die Echtzeituhr
Reset_RTC
		lda #$00
		sta $dc0b		;Stunden, schreiben stoppt Uhr
		sta $dc0a		;Minuten
		sta $dc09		;Sekunden
		sta $dc08		;Zehntel, schreiben startet Uhr
		rts

!zone Screenroutines		
MoveScreenUp			;neue Hardcopy-Routine, bewegt nur jede 9. Zeile
		lda #$0d		;Beginn der Berechnung mit Zeile 13
		clc
		adc Counter_Spacelines	;Leerzeilenzhler dazu
		cmp #$11		;muss die oberste Zeile gelscht werden?
		bne .LineCopy 	;wenn nicht, beim Scrollen weitermachen
		pha				;Akku auf Stapel
		ldy #$27		;40 Spalten
		lda #$20		;Bildschirmcode Leereichen
.LeerzeileOben
		sta $0400,y		;ins Video-RAM schreiben
		dey				;schon 40 Zeichen gelscht?
		bpl .LeerzeileOben	;wenn nicht, fortfahren
		pla				;Akku zurckholen
		
.LineCopy
		tax				;errechnete Zeilennummer in X
		jsr $e9f0		;Zeiger auf Video-RAM fr Zeile X (Ergebnis steht in $d1 $d2)
		lda $ecf1,x		;Low-Byte holen
		sta $ac			;und speichern
		lda $da,x		;High-Byte
		jsr $e9c8		;Bildschirmzeile nach oben schieben
		jsr $e9f0		;erneut Zeiger auf Video-RAM fr Zeile X holen
		ldy #$27		;40 Spalten
		lda #$20		;Leerzeichen
.Leerzeile
		sta ($ac),y		;ins Video-RAM schreiben
		dey				;schon 40 Zeichen gelscht?
		bpl .Leerzeile	;wenn nicht, fortfahren
		
		txa				;Zeilennummer in Akku
		sec
		sbc #$09		;9 Zeilen abziehen
		bcs .LineCopy	;nchste Zeile kopieren, falls Zeilennr >=0
		;ansonsten nchster Screendurchlauf
		dec Counter_Spacelines	;Zhler verringern
		bne EndMoveScreenUp ;Zhler noch >0?
		lda #$09		;ansonsten neu initialisieren
		sta Counter_Spacelines
		;neue Zeile einfgen
		ldx $0286		;Farbe laden
		ldy #$27		;Zeiger setzen
		sty PlatformFlag	;ins Flag irgendwas >0 schreiben
Copy_PlatformLine_To_Bottom
		lda TempLine,y	;Zeichen holen
		sta $0798,y		;und in Zeile 24 schreiben
		txa				;FarbRAM schreiben
		sta $db98,y
		dey				;nchstes Zeichen
		bpl Copy_PlatformLine_To_Bottom ;fertig, dann weiter
		
		;Level-Rechner
		lda Counter_Platformlines	;Reihen laden
		cmp #59			;Schon 60?
		beq IncreaseLevel	;dann Level erhhen
		inc Counter_Platformlines	;ansonsten Reihen erhhen
		jmp EndMoveScreenUp	;und Ende
IncreaseLevel
		inc Level_Nr	;Level erhhen
		lda #$00		;Reihen zurcksetzen
		sta Counter_Platformlines
		ldx #$18		;letzte Stelle der Levelanzeige
		jsr IncDigitX
		lda $0286		;Plattformfarbe switchen
		eor #$06
		sta $0286
EndMoveScreenUp
		rts


!zone GameMain
GameMain				;hier kommt das eigentliche Spiel hin
		
Wait_GameTimingFlag
		lda GameTimingFlag	;Timing: Kontrollen nur 1x pro Frame aktiv
		bne Wait_GameTimingFlag
		inc GameTimingFlag	;Sperrflag wieder setzen
		
		lda ActivePickType	;wurde ein Bonus-Gegenstand aufgesammelt?
	sta Testpos
		beq .EndPickTimer
		lda $dc09		;Sekundentimer
		cmp #$10		;Bonus schon 10sec aktiv? (BCD-Format)
		bne .EndPickTimer
		lda #$00		;Bonus lschen
		sta ActivePickType
.EndPickTimer
	
		lda #$04		;Joystickabfrage links Port 2
		bit $dc00
		bne .P1NotLeftPressed
		jsr Player1MoveLeft
		
.P1NotLeftPressed
		lda #$08		;Joystickabfrage rechts Port 2
		bit $dc00
		bne .P1NotRightPressed
		jsr Player1MoveRight

.P1NotRightPressed
		jsr Player1MoveDown
		
		lda $d001		;Y-Position Player1
		cmp #$1c		;oberes Ende
		bcc ExitGame	;Pos kleiner? dann Ende
		cmp #$e1		;unteres Ende
		bcs ExitGame	;Pos grer? dann Ende
		dec FrameTimer
		bne EndIncP1Score
		ldx #$09		;letzte Stelle der Punktanzeige
		jsr IncDigitX
		lda #$32
		sta FrameTimer
EndIncP1Score
		jsr CheckPickP1
		;soll ein Pick erzeugt werden? Wenn noch keins vorhanden, Wahrscheinlichkeit 1:40
		jsr HandlePickfruits
		
		lda PlatformFlag	;muss eine neue Plattformreihe erzeugt werden?
		beq EndMainLoop
		jsr CreatePlatformLine

EndMainLoop
		jmp GameMain	;weiter im Spiel

ExitGame
		sei
		lda #$00		;Rasterstrahl als Inter-
		sta $d01a		; rupt-quelle ausschalten
		ldx #$31		;IRQ-Vektor auf Standard
		ldy #$ea
		stx $0314
		sty $0315
		lda #$81		;Timer-IRQ erlauben
		sta $dc0d
		cli
		lda #$00
		sta $d404		;Musik ausschalten
		sta $d40b
		sta $d412
		lda $d015		;Sprites 0-5 + 7 ausschalten
		and #$40
		sta $d015
		lda #$1b		;Verschieberegister auf Einschaltwert
		sta $d011
		ldx #$0c		;Cursor auf Bildmitte
		ldy #$0e		; positionieren
		clc				;Carry lschen schaltet Routine auf
		jsr $fff0		;Cursor setzen
		lda #$02		;Zeichenfarbe rot
		sta $0286
		lda #<GameOverText
		ldy #>GameOverText
		jsr $ab1e		;String ausgeben
		;evtl einen squeeze-Sound
		;hier eine 2-Sekunden-Pause einfgen
		lda #$ff		;Joystick-Eingnge ausschalten
		sta $dc02
		jsr Reset_RTC
.Wait4sec
		lda $dc09		;Sekunden RTC 1 lesen
		cmp #$04		;4 Sekunden?
		bne .Wait4sec
		;lda #$15		;Zeichensatz-Register wieder auf Standard
		;sta $d018
		rts
		
!zone PlayerMove
Player1MoveLeft
		lda $07f8
		ora #%00000010	;Bit1 setzen, Linksbewegung immer Sprite 3+4
		dec PlayerAnimationDelay
		bne NoLeftAnimationP1
		eor #%00000001	;Bit0 switchen
		ldx #$06
		stx PlayerAnimationDelay
NoLeftAnimationP1
		sta $07f8
		lda $d010		;MSB X-Pos holen
		and #$01		;Bit 0
		bne P1IsRight	;gesetzt? dann unten weiter
		lda $d000		;Sprite1 X-Pos
		cmp #$18		;grer als 18 Pixel bis zum linken Rand?
		bcc EndP1MoveLeft	;nein, dann nix tun
		dec $d000		;ansonsten Position vermindern
		dec $d000
		rts				;und Ende
P1IsRight
		dec $d000		;X-Pos vermindern
		dec $d000
		bpl EndP1MoveLeft	;fand ein berlauf statt?
		lda $d010		;wenn ja, MSB lschen
		and #$fe
		sta $d010
EndP1MoveLeft		
		rts

Player1MoveRight
		lda $07f8
		and #%11111101	;Bit1 lschen, Rechtsbewegung immer Sprite 1+2
		dec PlayerAnimationDelay
		bne NoRightAnimationP1
		eor #%00000001	;Bit0 switchen
		ldx #$06
		stx PlayerAnimationDelay
NoRightAnimationP1
		sta $07f8
		lda $d010		;MSB X-Pos holen
		and #$01		;Bit 0
		beq P1IsLeft	;gelscht? dann unten weiter
		lda $d000		;Sprite1 X-Pos
		cmp #$47		;kleiner 256+61 Pixel? (wg breiten Plattf. ist 8 Px in den Rand zulssig)
		bcs EndP1MoveRight	;nein, dann nix tun
		inc $d000		;ansonsten Position erhhen
		inc $d000
		rts				;und Ende
P1IsLeft
		inc $d000		;X-Pos erhhen
		inc $d000
		bne EndP1MoveLeft	;fand ein berlauf statt?
		lda $d010		;wenn ja, MSB setzen
		ora #$01
		sta $d010
EndP1MoveRight
		rts

Player1MoveDown
		inc $d001
		lda $d01f		;Sprite-Hintergrund-Kollisionsregister
		and #$01		;Sprite 0 prfen
		beq EndPlayer1MoveDown	;keine Kollision? weiter fallen
		;Check ob wir hngengeblieben sind
		lda $d001		;Y-Position
		sec
		sbc #$1d		;$1d Rasterzeilen Rand abziehen
		lsr				;Ergebnis ganzzahlig durch 8 teilen ergibt Zeichenzeile
		lsr
		lsr
		tax				;errechnete Zeilennummer in X
		jsr $e9f0		;Zeiger auf Video-RAM fr Zeile X (Ergebnis steht in $d1 $d2)
		lda $d000		;X-Position
		pha
		lda $d010		;MSB ins Carry
		lsr				;1x schieben fr Sprite 0
		pla
		ror				;Ergebnis ganzzahlig durch 8 teilen ergibt Zeichenspalte
		lsr
		lsr
		sec
		sbc #$03		;$18 Pixel (=3 Zeichen) Rand abziehen
		tay
		lda ($d1),y		;Zeichen an der berechneten Position laden
		cmp #$20		;Leerzeichen?
		beq EndPlayer1MoveDown	;dann weiter fallen
		dec $d001		;ansonsten wieder 2 Pixel hher
		dec $d001
EndPlayer1MoveDown
		rts


!zone Subroutinen
;Subroutine FirstInit setzt Variablen die bei Systemstart undefiniert sind
FirstInit
		jsr LoadHighscore	;Highscoredatei laden
		;jsr CreateSpriteColortable
		rts

;64. Bytes auslesen 		
CreateSpriteColortable
		ldx #$88		; 1. Spriteblock 136
		ldy #$9f		;letzter Spriteblock 159
		iny
		sty $02
getnextcolor
		txa
		sta read64thbyte+2 ;??
		lsr ;2x rechtschieben = 6x linksschieben
		php
		lsr
		ora #$00 ; $40, $80, $c0 je nach VIC-Bank
		sta read64thbyte+2
		lda #$7f
		ror
		plp
		bcc *+4 ;gemerktes Bit zurechtwurschteln
		ora #$40
		sta read64thbyte+1
read64thbyte
		lda $1234 ;selbstmodifiziert
		sta PickSpriteColors-136,x	;1. block abziehen, fr eine allgemeine Routine mssten hier 256 Bytes reserviert sein
		inx
		cpx $02 ;#<(endblock+1) ;damit der Assembler nicht meckert wenn letzter Spriteblock = 255
		bne getnextcolor
		rts

;Subroutine IncDigitX erhht eine Ziffer in der Statuszeile
IncNextDigit
		lda #$30		;Bildschirmcode 0
		sta $07c0,x		;an Adresse schreiben
		dex				;Zhler auf nchstlinkes Byte
IncDigitX			;numerische Anzeige in der Statuszeile erhhen
		inc $07c0,x		;Byte erhhen
		lda #$3a		
		cmp $07c0,x		;berlauf?
		beq IncNextDigit
		rts
		
;Subroutine gibt Player1 100 Punkte		
Add100Points
		ldx #$07		;drittletzte Stelle der Punktanzeige
		jsr IncDigitX	;100 Punkte geben
		dey
		bne Add100Points	;wiederhole * LevelNr (geht vielleicht auch schner)
		rts

;Subroutine gibt Player1 50 Punkte		
Add50Points
		ldx #$08		;vorletzte Stelle der Punktanzeige
		jsr IncDigitX	;5x 10 Punkte geben
		ldx #$08
		jsr IncDigitX
		ldx #$08
		jsr IncDigitX
		ldx #$08
		jsr IncDigitX
		ldx #$08
		jsr IncDigitX
		rts

;Subroutine GetRandom liefert eine Zufallszahl im Akku
GetRandom
		lda $dc04
		eor $dc05
		eor $dd04
		adc $dd05
		eor $dd06
		eor $dd07
		rts

;erwartet Speicheradresse im ZP-Pointer $63/64, Maximallnge in A
InputString
		sta MaxInputLength
		ldy #$00		; Zeichenzhler=0
        sty TempByte
		sty $cc			;Blinkflag
eingabe jsr GETIN		; Zeichen einlesen
		beq eingabe		; wenn keine Taste gedrckt --> zurck zur Eingabe

		cmp #13			; wenn <Return>-Taste --> Programmende
		beq ende

		cmp #20			; wenn nicht die DEL-Taste --> verzweige nach weiter
		bne weiter
		ldy TempByte
		beq eingabe		; wenn Zeichenzhler=0 --> DEL-Taste ignorieren
		dec TempByte	; Zeichenzhler-1
		jmp out			; DEL ausfhren

weiter  cmp #32			; nur Zeichen mit Ascii-Code zwischen 32 und 95 zulassen
		bcc eingabe		; wenn < 32 --> zurck zur Eingabe
		cmp #96
		bcs eingabe		; wenn > 95 --> zurck zur Eingabe

ausgabe ldy TempByte
		cpy MaxInputLength
		bcs eingabe		; wenn max. Eingabelnge erreicht --> Zeichen ignorieren
		sta ($63), y	; Zeichen speichern
		inc TempByte	; Zeichenzhler +1
out     jsr BSOUT		; Zeichen ausgeben
		jmp eingabe

ende    ;lda #0			; das Ende des Textes mit 0 abschlieen
		;ldy TempByte
		;sta ($63), y
		lda  #$01
		sta $cc			;Blinkflag aus
		rts

;Subroutine prft ob Spieler1 was aufgesammelt hat
CheckPickP1
		lda $d01e		;Sprite-Sprite-Kollisionsregister
		and #%10000001	;Sprite 0 und 7 kollidiert?
		bpl EndCheckPickP1
		lda #%01111111	;Sprite7 ausschalten
		and $d015
		sta $d015
		lda CurrentPickType	;Bonus-Typ
		beq NoBonusPick
		sta ActivePickType
		jsr Reset_RTC
		rts
NoBonusPick
		lda ActivePickType
		cmp #$06		;HalfScore?
		bne EndHalfscore
		lda Level_Nr
		lsr				;Level halbieren
		tay
		bcc +			;war Level ungerade ist Carry gesetzt
		jsr Add50Points
+		tya
		beq EndCheckPickP1		;ganzzahliger Rest >0?
		jsr Add100Points
		rts
EndHalfscore
		cmp #$05		;DoubleScore?
		bne EndDoublescore
		ldy Level_Nr	;Level laden, hhere Level geben mehr Punkte
		jsr Add100Points
EndDoublescore
		ldy Level_Nr
		jsr Add100Points
EndCheckPickP1
		rts
		
;Subroutine HandlePickfruits kmmert sich um die Sammelfrchte
HandlePickfruits
		lda $d015		;SpriteEnableRegister
		and #%10000000
		beq NoActivePick
		dec $d00f		;Sprite Pickfruit nach oben
		lda $d00f
		cmp #$18
		bcc +			;wenn noch nicht oben, nix weiter tun
EndPickCheck
		rts
+		lda #%01111111	;ansonsten Sprite7 ausschalten
		and $d015
		sta $d015
		jmp EndPickCheck	;weiter im Spiel
NoActivePick
		lda DelayCounter
		beq CreateNewDelay
		dec DelayCounter
		bne EndPickCheck
		lda #%01111111	;MSB Sprite7 ausschalten
		and $d010
		sta $d010
		jsr GetRandom	;X-Position zufllig holen
		clc
		adc #$20		;mehr in die Mitte schieben
		sta $d00e
		bcc PickEnable
		lda #%10000000	;MSB Sprite7 setzen
		ora $d010
		sta $d010
PickEnable
		jsr GetRandom	;Zufallswert fr Pick-Typ
	;lda #$06 ;test
		tax
		and #$07		;maximal 24: erstmal 0-7 extrahieren
		sta CurrentPickType
		txa
		lsr				;hohe 4 Bits als 0-15 nehmen
		lsr
		lsr
		lsr
		clc
		adc CurrentPickType	;ergibt zusammen 0-23
		;Prfen ob schon ein Bonus aktiv ist, dann darf kein neuer kommen
		ldy ActivePickType
		beq +			;kein Bonus aktiv, dann weiter
		cmp #$07		;aktuelles Pick wre ein Bonus?
		bcs +			;wenn >=7 dann weiter
		clc
		adc #$07		;ansonsten Akku um 7 erhhen
+		tax
		sta CurrentPickType
		clc
		adc #(sprites/64)+7	;Sprite-Basis addieren, PlayerSprites berspringen
		sta $07ff		;Pointer setzen
		lda #$e0		;Y-Koordinate
		sta $d00f
		lda PickSpriteColors-1,x	;Sprite-Farbe
		sta $d02e
		bpl SingleColor	;Farbwert >128 bedeutet Sprite-Multicolor
		lda #%10000000
		ora $d01c
		bmi SetSpriteColorMode7 ;unbedingter Sprung
SingleColor
		lda #%01111111
		and $d01c
SetSpriteColorMode7
		sta $d01c
		lda #%10000000	;Sprite7 einschalten
		ora $d015
		sta $d015
		;wenn Pick kein Bonus, Typ auf 0 setzen
		lda CurrentPickType
		cmp #$08
		bcc +
		lda #$00
		sta CurrentPickType
+		rts
CreateNewDelay
		jsr GetRandom
		sta DelayCounter
		rts
		
;Subroutine CalcLeveldataBase ermittelt die Basisadresse fr die Leveldatenzeile
CalcLeveldataBase	;Adresse im Speicher derzeit $0b5b
		lda Counter_Platformlines
		beq CalcNewLevel	;hatten wir schon 60 Reihen?
		lda #$05		;ansonsten Pointer 5 Bytes weiterschieben
		clc
		adc LevelArrayPointer
		sta LevelArrayPointer
		bcs +
		rts
+		inc LevelArrayPointer+1
		rts
CalcNewLevel
		lda Level_Nr	;aktuellen Level
		sec				;solange 10 abziehen bis wir unter 0 sind
ReduceToTen
		sbc #$0a
		bcs ReduceToTen
		adc #$09		;jetzt haben wir einen Wertebereich 0-9
		sta $28			;den Wert direkt ins Multiplikationsregister
		clc
		adc $28			;und verdreifachen
		adc $28
		sta $28
		jsr GetRandom	;Zufallszahl
		sec
		sbc #$55
		bcc +			;war im 1. Drittel
		inc $28
		sbc #$55
		bcc +			;war im 2. Drittel
		inc $28
+						;$28 sollte jetzt Wertebereich 0-29 haben
		lda #$00		;Hi-Byte in Multiplikationsregister schreiben
		sta $29
		lda #$2c		;300 ins andere Register (300 Bytes pro Level)
		sta $71
		lda #$01
		sta $72
		jsr $b357		;Multiplikation
		stx LevelArrayPointer	;Leveldaten beginnen bei $3000, Lo-Byte kann direkt verwendet werden
		tya				;Hi-Byte muss addiert werden
		clc
		adc #>LevelData
		sta LevelArrayPointer+1
		rts
		
;Subroutine CreatePlatformLine liest 5 Bytes Leveldaten und speichert diese als Char in der TempLine
CreatePlatformLine
		jsr CalcLeveldataBase	;Speicheradresse der Datenzeile muss bekannt sein
		ldx #$27		;40 Zeichen pro Zeile
		ldy #$04		;5 Bytes werden gebraucht (Abbruch bei Unterlauf)
ConvertByteStart
		lda #$04		;4x 2 Bits verschieben (Abbruch bei 0)
		sta Shiftcounter
		lda (LevelArrayPointer),y
ConvertByteLoop
		pha				;Akku sichern, wird durch AND verndert
		and #$03		;letzte 2 Bits isolieren
		jsr BuildTempLine
		pla				;Akku wieder holen
		lsr
		lsr
		dec Shiftcounter
		bne ConvertByteLoop
		dey
		bpl ConvertByteStart
		lda #$00
		sta PlatformFlag	;Flag lschen
		rts

;Subroutine BuildTempLine schreibt in Abhngigkeit vom Akku 2 Zeichen in die TempLine		
BuildTempLine	;A: Schalter 0-3, X: Zeichenzhler, Y: besetzt
		cmp #$01
		beq ._1
		cmp #$02
		beq ._2
		cmp #$03
		beq ._3
._0		lda #$20		;Leerzeichen
		jmp +
._3		lda #$42		;Boden-Zeichen
+		sta TempLine,x
		dex
.all	sta TempLine,x
		dex
		rts
._1		lda #$41		;Bodenzeichen
		sta TempLine,x
		dex
		lda #$40		;linker Rand
		jmp .all
._2		lda #$44		;rechter Rand
		sta TempLine,x
		dex
		lda #$43		;Boden-Zeichen
		jmp .all
		
;Subroutine ShowKoalapic zeigt ein Koalabild an
ShowKoalapic
		lda $d015		;Sprites 0-5 + 7 ausschalten
		and #$40
		sta $d015
		lda $dd00		;VIC auf Bank 1 schalten
		and #$fe
		ora #$02
		sta $dd00
		lda #$d8		; multicolor modus einschalten
		sta $d016
		lda #$78		; bitmap bei $2000, videoram bei $1c00 aktivieren
		sta $d018		;wegen Bank1 $6000				 $5c00
		lda #$3b		; auf bitmap modus umschalten
		sta $d011
		lda #$00		;Rahmen- und Hintergrundfarbe auf schwarz
		sta $d020
		sta $d021
		ldx #$00		; farbdaten ins videoram btw colorram kopieren
GraphicCopyLoop
		lda videoram,x
		sta $5c00,x
		lda videoram+$0100,x
		sta $5d00,x
		lda videoram+$0200,x
		sta $5e00,x
		lda videoram+$02f7,x
		sta $5ef7,x
		lda colorram,x
		sta $d800,x
		lda colorram+$0100,x
		sta $d900,x
		lda colorram+$0200,x
		sta $da00,x
		lda colorram+$0300,x
		sta $db00,x
		inx
		bne GraphicCopyLoop
SwitchGraphicColor		;ColorRAM d814-d827 schwarz/gelb switchen, macht das "Press Fire" im Titelbild sichtbar
		ldx #$13
		lda $d814
		eor #$07
-		sta $d814,x
		dex
		bpl -
		lda #240		;4 Sekunden
		ldx #<SwitchGraphicColor
		ldy #>SwitchGraphicColor
		jsr SetTimer
		inc DelayCounter
		rts

;Subroutine ShowCredits
ShowCredits
		;lda #$06
		;sta $d021		;Hintergrundfarbe blau sieht doof aus
		ldx #$00		;Credits-Screen kopieren
-		lda $5800,x
		sta $0400,x
		lda $5900,x
		sta $0500,x
		lda $5a00,x
		sta $0600,x
		lda $5afe,x
		sta $06fe,x
		lda #$07		;Zeichenfarbe gelb
		sta $d800,x
		sta $d900,x
		sta $da00,x
		sta $db00,x
		dex
		bne -
		lda #$00
		sta $d010		;Sprite MSB lschen
		sta $d017		;Doppelhhe aus
		sta $d01d		;Doppelbreite aus
		sta $d01c		;Multicolor
		lda #$2c		;Sprite-Positionen X
		sta $d000
		sta $d004
		sta $d008
		lda #$ca
		sta $d002
		sta $d006
		sta $d00a
		lda #$85		;Sprite-Positionen Y
		sta $d001
		sta $d003
		lda #$94
		sta $d005
		sta $d007
		lda #$a6
		sta $d009
		sta $d00b
		lda #$0a		;Sprite-Farben
		sta $d02d
		sta $d02e
		ldx #$06
-		lda PickSpriteColors,x
		sta $d027,x
		dex
		bpl -
		lda $d015
		ora #%00111111	;Sprites 0-5 einschalten
		sta $d015
		rts

;Subroutine MusicOnOff schaltet die Hintergrundmusik ein/aus
MusicOnOff
		lda MusicEnabled
		eor #$01
		sta MusicEnabled
		bne dontcopy	;bei ausgeschaltenem Symbol sind die Sprite-Daten egal
		ldx #$40		;Status-Sprite kopieren
-		lda $27c0,x
		sta $0340,x		;Bank 0 Block 13
		sta $53c0,x		;Bank 1 Block 79
		dex
		bpl -
		lda #$0d		;Bank 0 Block 13
		sta $07fe
		lda #$4f		;Bank 1 Block 79
		sta $5ffe
		lda #$18
		sta $d00c		;Sprite 6 x
		lda #$28
		sta $d00d		;Sprite 6 y
		lda #$01
		sta $d02d		;wei
		lda $d01c
		and #%10111111
		sta $d01d		;Multicolor aus
dontcopy	lda $d015
		eor #%01000000
		sta $d015		;ein/aus
		rts
		
*=$1000
		!bin "Chris_02.sid",,$7c+2 ; sid player einfgen, startadresse und psid header berspringen 

;------------------------------------------------------------
;game variables
;------------------------------------------------------------
*=$1f00
Level_Nr  
		!byte 1			;255 Level sollten doch genug sein, oder?
Counter_Scrollregister
		!byte 0			;Pixelverschiebung bei Softscrolling
Counter_Spacelines
		!byte 0			;Zwischenraum zwischen den Plattformen (9 Char-Lines)
Counter_Platformlines
		!byte 0			;Plattform-Zhler (60 pro Level)
GameTimingFlag
		!byte $01		;Sperrflag fr Spielerkontrolle
PlatformFlag
		!byte $00		;Anforderungsflag fr neue Plattformreihe
FrameTimer
		!byte $32		;alle 50 Frames (=1 Sekunde) gibts 1 Punkt
PlayerAnimationDelay
		!byte 6,6		;Spritewechsel alle x Frames (2. Byte Player2)
NumberOfPlayers
		!byte 0			;Flag fr 1 oder 2 Spieler
ActivePickType
		!byte 0			;hat ein Spieler einen Bonus aktiv? (Spieler2 = Bit7 gesetzt)
CurrentPickType
		!byte 0			;ist das Pick auf dem Screen ein Bonus oder normale Frucht?
MusicEnabled
		!byte 1			;Musik ausgeschalten?

PickSpriteColors ;Spritefarben, >128 = Multicolor
		!byte 2,4,15,202,5,2,1,8, 9,210,11,12,13,6,15, 200,201,202,203,204,205,206,207,208
TitleText
		!text "PRESS P1 OR P2 FIRE"	; fr Titelscreen
		!byte 0			;String-Ende-Zeichen
StatuslineText
		!text " P1 000000      LEVEL 001     000000 P2"	;Statuszeile
		; 07c0+0123456789abcdef0123456789abcdef01234567
		!byte 0			;String-Ende-Zeichen
GameOverText
		!text " GAME OVER "	;fr GameOver
		!byte 0			;String-Ende-Zeichen
EnterNameText
		!text "ENTER YOUR NAME"	;fr Highscore-Eintrag
		!byte 0			;String-Ende-Zeichen
Shiftcounter !byte 4	;frs Bitshiften
ScoreTablePointer !byte 0,0	;Zeiger auf aktuell auszugebende Highscore-Adresse
MaxInputLength !byte 0	;maximale Lnge fr String-Eingabe
TempByte !byte 0,0,0	;Zwischenspeicher
TempLine				;Zwischenspeicher fr die nchste Plattformreihe
		!fill 40,32

*=$2000
sprites
		;Player-Sprites mssen an einer durch 4 teilbaren Zeigeradresse stehen
		!bin "downfall.spr" ; Sprites nach $2000 laden
	
*=$2800
		!bin "downfall.chr" ; Den Charset nach $2800 laden
		
*=$3000
LevelData
		!bin "leveldaten.bin",,2 ; Leveldaten laden und die Startadresse abschneiden

*=$5800
Credits
		!scr "                                        "
		!scr "                 credits                "
		!scr "                                        "
		!scr "   template           graham humphrey   "
		!scr "   programming                salator   "
		!scr "   graphics                  predseda   "
		!scr "   music                     chris 02   "
		!scr "   level design               mihcael   "
		!scr "   publicity          genesis project   "
		!scr "                                        "
		!scr " -------------------------------------- "
		!scr "                                        "
		!scr "     speed-up            slow-down      "
		!scr "                                        "
		!scr "     fall slower         fall faster    "
		!scr "                                        "
		!scr "     double score        half score     "
		!scr "                                        "
		!scr "            ...for ten seconds          "
		!scr "                                        "
		!scr " fire joystick port 2 for single player "
		!scr "   or joystick port 1 for double player "
		!scr " m turns music on/off                   "
		!scr "                                        "
		!scr "     www.rollingpet.de/c64/downfall     "
		!fill 16,32
		!byte 136,137,138,139,140,141,13	;Sprite-Pointer

*=$6000
TitlePicture
	!bin "downfall_title_koala.koa",$1f40,2
videoram
	!bin "downfall_title_koala.koa",$03e8,2+$1f40
colorram
	!bin "downfall_title_koala.koa",$03e8,2+$1f40+$03e8

DeleteFilename
		!text "S0:"
ScoreFilename
		!text "THE FALLEN GUYS"
ScoreTitle		
		!text "HALL OF                                         FALL"
		!byte 0		;String-Ende-Zeichen
ScoreTable
		!scr "000200@ATARI JAGUAR@"	;20 Scores a 6 Zeichen + Nullbyte, Namen a 12 Zeichen + Nullbyte
		!scr "000190@BLITZBASIC..@"
		!scr "000180@COMMODORE 64@"
		!scr "000170@DOWNFALL....@"
		!scr "000160@EASYFLASH 3.@"
		!scr "000150@FORUM64.DE..@"
		!scr "000140@GRAHAM......@"
		!scr "000130@HUMPHREY....@"
		!scr "000120@IEC.........@"
		!scr "000110@JACK TRAMIEL@"
		!scr "000100@KEYBOARD....@"
		!scr "000090@LOAD ERROR..@"
		!scr "000080@MIHCAEL.....@"
		!scr "000070@NO NAME.....@"
		!scr "000060@OUT OF MEMOR@"
		!scr "000050@PREDSEDA....@"
		!scr "000040@RAM.........@"
		!scr "000030@SALATOR.....@"
		!scr "000020@TEST TEAM...@"
ScoreTableLast
		!scr "000010@U...........@"
ScoreTableEnd
		!scr "000000@............@"	;Sicherheitspuffer, ich glaub der Highscorecheck berschreibt das
!zone Highscore
LoadHighscore
		lda #ScoreTitle-ScoreFilename		;Lnge Dateiname
		ldx #<ScoreFilename
		ldy #>ScoreFilename
		jsr SETNAM
		lda #$01		;logische Filenummer
		ldx $ba			;letztes Gert
		bne +			;wenn es kein Gert gibt,
		ldx #$08		; Disk8 nehmen
+		ldy #$00		;Sekundradresse, gespeicherte Ladeadresse ignorieren
		jsr SETLFS
		ldx #<ScoreTable	;Ladeadresse festlegen
		ldy #>ScoreTable
		lda #$00		;0=load, 1= verify
		jsr $ffd5		;LOAD
		bcs IO_Error
		rts
IO_Error
		asl				;Fehlermeldung ausgeben (abgespeckte $a43a)
		tax
		lda $a326,x
		sta $22
		lda $a327,x
		sta $23
		ldy #$00
-		lda ($22),y
		pha
		and #$7f
		jsr $ab47
		iny
		pla
		bpl -
		lda #$ef		;eine kleine Pause
		sta GameTimingFlag
.WaitRaster
		cmp $d012
		bne .WaitRaster
		dec GameTimingFlag
		bne .WaitRaster
		rts

SaveHighscore
		jsr ScratchHighscore	;alte Datei lschen
		lda #ScoreTitle-ScoreFilename	;Lnge Dateiname
		ldx #<ScoreFilename
		ldy #>ScoreFilename
		jsr SETNAM
		lda #$01		;logische Filenummer
		ldx $ba			;letztes Gert
		bne +			;wenn es kein Gert gibt,
		ldx #$08		; Disk8 nehmen
+		ldy #$00		;Sekundradresse, gespeicherte Ladeadresse ignorieren
		jsr SETLFS
		ldx #<ScoreTable	;Startadresse festlegen
		ldy #>ScoreTable
		stx $c1
		sty $c2
		;lda #$c1
		ldx #<ScoreTableEnd
		ldy #>ScoreTableEnd
		stx $ae
		sty $af
		jsr $f5ed		;SAVE (Vektoren schon passend gesetzt)
		bcs IO_Error
		rts

ScratchHighscore
		;ffnen des Befehlskanals
		lda #1			;logische Dateinummer
		ldx $ba			;letztes Gert
		bne +			;wenn es kein Gert gibt,
		ldx #$08		; Disk8 nehmen
+		ldy #15			;Sekundradresse
		jsr SETLFS		;Dateiparameter festlegen
		lda #0			;kein Dateiname
		jsr SETNAM		;Dateinamen festlegen
		jsr OPEN		;Kanal ffnen	
		;SCRATCH an Floppy absetzen
		ldx #1
		jsr CHKOUT		;Ausgabe auf Kanal 1 (Befehlskanal)
.cmdsend	
		ldx #ScoreTitle-ScoreFilename
		ldy #$00
.cmdloop
		lda DeleteFilename,y
		jsr BSOUT		;Byte senden
		iny
		dex
		bne .cmdloop
		jsr CLRCHN		;Ein-/Ausgabe zurcksetzen
		;Kanle schlieen
		lda #1
		jsr CLOSE		;Kanal schlieen

	
;Subroutine CheckHighscore prft auf Eintrag in die HS-Liste
CheckHighscore
		ldx #$05
-		lda $07dd,x		;Punktestand Spieler2 zwischenspeichern
		sta TempLine,x	;hier haben wir 40 Bytes die gerade nicht gebraucht werden
		dex
		bpl -
		lda #$c4		;Speicheradresse Player1
		ldy #$07
		jsr CompareScore	;Rang ermitteln
		cpx  #$14
		beq NoEntryP1
		clc				;$63 zeigt noch auf gewnschte Zeile, 7 Stellen addieren
		lda $63
		adc #$07
		sta $63
		bcc +			;bei berlauf Hibyte mitnehmen
		inc $64
+		jsr InputName
		jsr SaveHighscore
NoEntryP1
		rts
		
;Subroutine CompareScore ermittelt Position in der Liste
;erwartet Speicheradresse des Vergleichs-Strings in A/Y, Ergebnis in X
CompareScore
		sta $65			;ZP-Pointer 3: Playerscore
		sty $66
		lda #<ScoreTableLast
		ldy #>ScoreTableLast
		sta $61			;ZP-Pointer 1: Zeiger in Hiscoretabelle
		sty $62
		clc				;ZP-Pointer 2: Zeiger in Hiscoretabelle auf tieferen Eintrag
		adc #$14		;20 Zeichen
		sta $63
		bcc +
		iny
+		sty $64
		ldx #$14		;Zeilenzeiger (1-20)
CompareLoop
		ldy #$07		;Stellen-Zeiger (6)
		sec
		dey
		lda ($61),y		;Listenscore
		sbc ($65),y		;Playerscore abziehen
		dey
		lda ($61),y
		sbc ($65),y
		dey
		lda ($61),y
		sbc ($65),y
		dey
		lda ($61),y
		sbc ($65),y
		dey
		lda ($61),y
		sbc ($65),y
		dey
		lda ($61),y
		sbc ($65),y
		bpl NoHiscore
		;Kopieren der Punktzahl auf nchsttiefere Zeile
		ldy #$13
-		lda ($61),y
		sta ($63),y
		dey
		bpl -
		;Zeiger auf nchsthheren Highscore-Eintrag setzen		
		lda $62
		sta $64
		sec
		lda $61
		sta $63
		sbc #$14		;20 Zeichen
		sta $61
		bcs +			;bei berlauf Hibyte mitnehmen
		dec $62
+		dex
		bne CompareLoop
NoHiscore
		;Einfgen des Playerscore
		ldy #$12		;Name leeren
		lda #$2e
-		sta ($63),y
		dey
		cpy #$07
		bcs -
		ldy #$05		;Punkte kopieren
-		lda ($65),y
		sta ($63),y
		dey
		bpl -
		lda $63			;Zeiger zwischenspeichern damit bei Eingabe nicht neu berechnet werden muss
		sta TempByte+1
		lda $64
		sta TempByte+2
		rts		;Platz steht in X
		
;Subroutine InputName zum Eingeben in der Highscoreliste
InputName
		txa				;Platzierung sichern
		pha
		jsr ShowHighscore
		ldx #$02
		ldy #$04		;... Spalte
		clc				;Carry lschen schaltet Routine auf
		jsr $fff0		;Cursor setzen
		lda #$01		;Zeichenfarbe wei
		sta $0286
		lda #<EnterNameText
		ldy #>EnterNameText
		jsr $ab1e		;Kopfzeile ausgeben
		pla				;Platzierung zurckholen
		clc
		adc #$04		;4 Kopfzeilen addieren
		tax
		ldy #$08		;8. Spalte
		clc				;Carry lschen schaltet Routine auf
		jsr $fff0		;Cursor setzen
		lda TempByte+2
		sta $64
		lda TempByte+1	;zwischengespeicherte Adresse zurckholen
		clc
		adc #$07		;7 Stellen weiterrcken
		sta $63
		bcc +
		inc $64
+		lda #$0c		;maximale Eingabelnge
		jsr InputString	;Name eingeben
		rts

ShowHighscore
		lda #$03		;VIC Bank 0
		ora $dd00
		sta $dd00
		lda #$c8		;Multicolor aus, 40 Spalten (Register auf Grundwert)
		sta $d016
		lda #$1b		;Grafik aus
		sta $d011
		lda #$1a		;Videospeicher bei $0400, Zeichensatz bei $2800
		sta $d018
		jsr $e544		;Bildschirm lschen
		lda #$00		;Hintergrund und Rand schwarz
		sta $d020
		sta $d021
		ldx #$00		;Cursor in erste Zeile
		ldy #$0d		;... Spalte
		clc				;Carry lschen schaltet Routine auf
		jsr $fff0		;Cursor setzen
		lda #$0a		;Zeichenfarbe hellrot
		sta $0286
		lda #<ScoreTitle
		ldy #>ScoreTitle
		jsr $ab1e		;Kopfzeile ausgeben
PrintHighscore			;Highscoreliste ausgeben
		lda #$0f		;Zeichenfarbe hellgrau
		sta $0286
		lda #<ScoreTable
		sta ScoreTablePointer
		lda #>ScoreTable
		sta ScoreTablePointer+1
		ldx #$04		;Cursor in erste Zeile
PrintNextLine
		stx TempByte
		ldy #$18		;... Spalte
		clc				;Carry lschen schaltet Routine auf
		jsr $fff0		;Cursor setzen
		lda ScoreTablePointer
		ldy ScoreTablePointer+1
		jsr $ab1e		;String ausgeben
		ldx TempByte
		ldy #$08		;... Spalte
		clc				;Carry lschen schaltet Routine auf
		jsr $fff0		;Cursor setzen
		clc
		ldy ScoreTablePointer+1
		lda ScoreTablePointer
		adc #07
		bcc +
		iny
+		jsr $ab1e		;String ausgeben
		lda $0286		;Farbwechsel grau/orange
		eor #$07
		sta $0286
		clc
		lda ScoreTablePointer
		adc #20
		sta ScoreTablePointer
		bcc +
		inc ScoreTablePointer+1
+		ldx TempByte
		inx
		cpx #24
		bne PrintNextLine
		rts
